% TIDs_bt.m computes propagation velocities of GWs in 2D from Doppler signals a detect TIDs 
% Set path for data to read (variable cestadata) and to store results (variable cestaprint)
% Set tiskni to 2 if you want to store slowness maps, 1 otherwise 
% the files to analyse are specified in the listTID.txt file that has to be located in the same directory as this code
% It is possible to specify if all files will be analysed (justo=0) or just
% specific number of files
% Bandwidth can be changed by changing the HPF and LPF variables (4*60 and 50*60 are the recommended values)
 
clear all
Re=6378000;
c=2.99792458e8;

cestadata='D:\Data_obr\selected_3D_3f\20141108_foF2_OK_test\'; % path to read data
cestaprint='D:\Data_obr\selected_3D_3f\20141108_foF2_OK_test\'; % path to store results
 
outtext='slowness_results_' ; % file to store-append the results
filelist='listTID.txt'
justo=0; % 0.. analyze all, M(1..x)..analyze M files

HPF=50*60; % periods longer than HPF (in seconds) are filtred (supressed)
LPF=4*60; % periods shorter than HPF (in seconds) are filtred (supressed)

tiskni=1; % 0 no print, 1..print output parameters i text file, 2..print output parameters in text file and slowness maps      
auto=0;  % 0.. standard processing, reading only Doppler shifts
         % 1.. process data from automatic approximation including power parameters 
formatOut='yyyy mm dd HH MM';         
filter=2; % 0.. no filter
          % 1 or 2..filer also for signal (phase velocities)
prah=0.5; % threshold for coherency parameter 
slowcor=1; % 1.. compute uncertainties from best beam and cross-correalations 
           % 0.. compute uncertainties from best beam for different overlapping subintervals 
           % 0.. is not supported in the last (current version)
          
prahpw=1e10; %thershold for power
prahqu=0.5; % threshold for quality - sharpness of spectral peak
prahTID=0.06; % threshold of RMS Doppler shift to indicate TIDs

Herm=0;  % 0.. CR, 1..SA (Hermanus), 2..Tucuman, 3..Taiwan
% select the subinterval 
delkai=90; okraj=9;
poctras3MHz=3;  % 
  
outtext=[outtext num2str(round(LPF/60)) '_' num2str(round(HPF/60)) '.txt']    

fidlist=fopen([cestadata filelist],'r');
if fidlist~=-1
  count=0; goon=1 
  while(~feof(fidlist)& goon)
     line=fgets(fidlist);
     Nl=length(line)
     if (Nl>22)&(line(Nl-5:Nl-2)=='.dat')
       count=count+1;
       if justo==count goon=0; end 
       file3MHz=line(Nl-23:Nl-2);
         
 %file3MHz=line(Nl-21:Nl-2);
%file3MHz= '130330_2000_4MHz_f.dat'   %'130613_0100_4MHz_f.dat';             %'090716_2000_d.dat'

sdate=['20' file3MHz(1:2) ' ' file3MHz(3:4) ' ' file3MHz(5:6) ' ']
stime=[file3MHz(8:9) ' ' num2str(round(delkai/2)+str2num(file3MHz(10:11)))]
sUTC=datestr(datenum([sdate stime],formatOut),formatOut);
sfreq=file3MHz(13);
skon='\r\n';

if slowcor==0
  pocv=[0 okraj 0 okraj];
  konv=[delkai delkai delkai-okraj delkai-okraj]; % in min
   %pocv=0; konv=delkai; 
else
  pocv=0; konv=delkai; 
end    

 
%coordinates of transmitters and receivers
latdeg_rec =50+02/60+27/60/60; longdeg_rec =14+28/60+38/60/60;  % UFA
latdeg_rec1=50+12/60+17/60/60; longdeg_rec1=12+30/60/+43/60/60;  % Kvetna

latdeg_vys1=50+31/60+41/60/60; longdeg_vys1=14+34/60+02/60/60;  % P.Ves
latdeg_vys2=49+59/60+26/60/60; longdeg_vys2=14+32/60+18/60/60;  % Pruhonice
latdeg_vys3=50+38/60+52/60/60; longdeg_vys3=13+39/60+23/60/60;  % Dlouha Louka  
latdeg_vys4=49+07/60+45/60/60; longdeg_vys4=13+34/60+38/60/60;  % Kasperske Hory
latdeg_vys5=50+14/60+8/60/60;  longdeg_vys5=12+22/60+24/60/60;  % Vackov

latdeg_iono=latdeg_vys2; longdeg_iono=longdeg_vys2;

if Herm==3
  latdeg_rec=24+58/60+19/60/60;  longdeg_rec=121+11/60+30/60/60; %NCU Zhongli
  latdeg_rec=23+57/60+18/60/60;  longdeg_rec=120+55/60+37/60/60; %Chi Nan University
  
  latdeg_vys1=23+53/60+50/60/60; longdeg_vys1=121+33/60+03/60/60; % Dong Hwa University (Hualien)
  latdeg_vys2=24+20/60+26/60/60; longdeg_vys2=120+46/60+41/60/60; % Sanyi 
  latdeg_vys3=24+43/60+04/60/60; longdeg_vys3=121+40/60+58/60/60; % Yilan
  latdeg_vys3=24.815758; longdeg_vys3=121.727314; % Fo Guang University since 2014
  
  latdeg_iono=latdeg_rec; longdeg_iono=longdeg_rec;  
end

if Herm==2
  latdeg_rec=-26.84;  longdeg_rec=-65.23; %Tucuman
  latdeg_iono=latdeg_rec; longdeg_iono=longdeg_rec;
  
  latdeg_vys1=-26.942802; longdeg_vys1=-65.707094; % El Mollar
  latdeg_vys2=-(26+33/60+48/60/60); longdeg_vys2=-(64+32/60+59/60/60); % Garmendia
  latdeg_vys3=-(27+29.958/60); longdeg_vys3=-(64+52.416/60); % Las Thermas
  latdeg_iono=latdeg_rec; longdeg_iono=longdeg_rec;
end
if Herm==1
    latdeg_rec=-(34+25/60+25.6/60/60);  longdeg_rec=19+13/60+25.5/60/60; %Hermanus 
    latdeg_iono=latdeg_rec; longdeg_iono=longdeg_rec;
    
    latdeg_vys1=-(33+39/60+57.6/60/60); longdeg_vys1=19+25/60+21.03/60/60; % Worcester
    latdeg_vys2=-(33+56/60+04.6/60/60); longdeg_vys2=18+28/60+38.6/60/60; % Cape Town
    latdeg_vys3=-(34+38/60+41.6/60/60); longdeg_vys3=20+13/60+39.0/60/60; % Arniston (Cape Aghulas)
    latdeg_vys4=-34.35; longdeg_vys4=19.49; % jen pro ucely GPS, Cape Point
    latdeg_iono=latdeg_rec; longdeg_iono=longdeg_rec;
end

latdeg_s1=1/2*(latdeg_vys1+latdeg_rec);
latdeg_s2=1/2*(latdeg_vys2+latdeg_rec);
latdeg_s3=1/2*(latdeg_vys3+latdeg_rec);
latdeg_s4=1/2*(latdeg_vys4+latdeg_rec);
latdeg_s5=1/2*(latdeg_vys5+latdeg_rec);
longdeg_s1=1/2*(longdeg_vys1+longdeg_rec);
longdeg_s2=1/2*(longdeg_vys2+longdeg_rec);
longdeg_s3=1/2*(longdeg_vys3+longdeg_rec);
longdeg_s4=1/2*(longdeg_vys4+longdeg_rec);
longdeg_s5=1/2*(longdeg_vys5+longdeg_rec);


% horizontal distances of reflection points from the ionosonde
hdy1=Re*pi/180*(latdeg_s1-latdeg_iono);
hdx1=Re*pi/180*(longdeg_s1-longdeg_iono)*mean([cos(latdeg_s1*pi/180) cos(latdeg_iono*pi/180)]);
hd1=sqrt(hdy1^2+hdx1^2);

hdy2=Re*pi/180*(latdeg_s2-latdeg_iono);
hdx2=Re*pi/180*(longdeg_s2-longdeg_iono)*mean([cos(latdeg_s2*pi/180) cos(latdeg_iono*pi/180)]);
hd2=sqrt(hdy2^2+hdx2^2);

hdy3=Re*pi/180*(latdeg_s3-latdeg_iono);
hdx3=Re*pi/180*(longdeg_s3-longdeg_iono)*mean([cos(latdeg_s3*pi/180) cos(latdeg_iono*pi/180)]);
hd3=sqrt(hdy3^2+hdx3^2);

% reference point in the center
if poctras3MHz==3
  latdeg_ref=1/3*(latdeg_s1+latdeg_s2+latdeg_s3);
  longdeg_ref=1/3*(longdeg_s1+longdeg_s2+longdeg_s3);
  %zref=1/6*(z1+z2+z3+z1_4+z2_4+z3_4)
end
if poctras3MHz==4
  latdeg_ref=1/4*(latdeg_s1+latdeg_s2+latdeg_s3+latdeg_s4);  
  longdeg_ref=1/4*(longdeg_s1+longdeg_s2+longdeg_s3+longdeg_s4);
  dx4=Re*pi/180*(longdeg_s4-longdeg_ref)*mean([cos(latdeg_s4*pi/180) cos(latdeg_ref*pi/180)]);
  dy4=Re*pi/180*(latdeg_s4-latdeg_ref);
 hdy4=Re*pi/180*(latdeg_s4-latdeg_iono);
 hdx4=Re*pi/180*(longdeg_s4-longdeg_iono)*mean([cos(latdeg_s4*pi/180) cos(latdeg_iono*pi/180)]);
 hd4=sqrt(hdy4^2+hdx4^2);
end
if poctras3MHz==5
  latdeg_ref=1/5*(latdeg_s1+latdeg_s2+latdeg_s3+latdeg_s4+latdeg_s5);  
  longdeg_ref=1/5*(longdeg_s1+longdeg_s2+longdeg_s3+longdeg_s4+longdeg_s5);
  dx4=Re*pi/180*(longdeg_s4-longdeg_ref)*mean([cos(latdeg_s4*pi/180) cos(latdeg_ref*pi/180)]);
  dy4=Re*pi/180*(latdeg_s4-latdeg_ref);
  dx5=Re*pi/180*(longdeg_s5-longdeg_ref)*mean([cos(latdeg_s5*pi/180) cos(latdeg_ref*pi/180)]);
  dy5=Re*pi/180*(latdeg_s5-latdeg_ref);
 hdy4=Re*pi/180*(latdeg_s4-latdeg_iono);
 hdx4=Re*pi/180*(longdeg_s4-longdeg_iono)*mean([cos(latdeg_s4*pi/180) cos(latdeg_iono*pi/180)]);
 hd4=sqrt(hdy4^2+hdx4^2);
 
 hdy5=Re*pi/180*(latdeg_s5-latdeg_iono);
 hdx5=Re*pi/180*(longdeg_s5-longdeg_iono)*mean([cos(latdeg_s5*pi/180) cos(latdeg_iono*pi/180)]);
 hd5=sqrt(hdy5^2+hdx5^2);
 alfa5=atan(hd5/mean([hi hi_4]));
end
dx1=Re*pi/180*(longdeg_s1-longdeg_ref)*mean([cos(latdeg_s1*pi/180) cos(latdeg_ref*pi/180)]);
dy1=Re*pi/180*(latdeg_s1-latdeg_ref);
dx2=Re*pi/180*(longdeg_s2-longdeg_ref)*mean([cos(latdeg_s2*pi/180) cos(latdeg_ref*pi/180)]);
dy2=Re*pi/180*(latdeg_s2-latdeg_ref);
dx3=Re*pi/180*(longdeg_s3-longdeg_ref)*mean([cos(latdeg_s3*pi/180) cos(latdeg_ref*pi/180)]);
dy3=Re*pi/180*(latdeg_s3-latdeg_ref);


%vypocet yij=yi-yj, ...., deleni dvema kvuli tomu, ze vzdalenost odraznych
%bodu je na pulce
y12=Re*pi/180*(latdeg_vys1-latdeg_vys2)/2;    x12=Re*pi/180*(longdeg_vys1-longdeg_vys2)/2*mean([cos(latdeg_vys1*pi/180) cos(latdeg_vys2*pi/180)]);
d12=2*sqrt(x12^2+y12^2); % vzdalenost vys1,2
y13=Re*pi/180*(latdeg_vys1-latdeg_vys3)/2;    x13=Re*pi/180*(longdeg_vys1-longdeg_vys3)/2*mean([cos(latdeg_vys1*pi/180) cos(latdeg_vys3*pi/180)]);
d13=2*sqrt(x13^2+y13^2);
y23=Re*pi/180*(latdeg_vys2-latdeg_vys3)/2;    x23=Re*pi/180*(longdeg_vys2-longdeg_vys3)/2*mean([cos(latdeg_vys2*pi/180) cos(latdeg_vys3*pi/180)]);
d23=2*sqrt(x23^2+y23^2);

if poctras3MHz>=4
  y14=Re*pi/180*(latdeg_vys1-latdeg_vys4)/2;    x14=Re*pi/180*(longdeg_vys1-longdeg_vys4)/2*mean([cos(latdeg_vys1*pi/180) cos(latdeg_vys4*pi/180)]);
  d14=2*sqrt(x14^2+y14^2);
  y24=Re*pi/180*(latdeg_vys2-latdeg_vys4)/2;    x24=Re*pi/180*(longdeg_vys2-longdeg_vys4)/2*mean([cos(latdeg_vys2*pi/180) cos(latdeg_vys4*pi/180)]);
  y34=Re*pi/180*(latdeg_vys3-latdeg_vys4)/2;    x34=Re*pi/180*(longdeg_vys3-longdeg_vys4)/2*mean([cos(latdeg_vys3*pi/180) cos(latdeg_vys4*pi/180)]); 
end
if poctras3MHz==5
  y15=Re*pi/180*(latdeg_vys1-latdeg_vys5)/2;    x15=Re*pi/180*(longdeg_vys1-longdeg_vys5)/2*mean([cos(latdeg_vys1*pi/180) cos(latdeg_vys5*pi/180)]);
  d15=2*sqrt(x15^2+y15^2);
  y45=Re*pi/180*(latdeg_vys4-latdeg_vys5)/2;    x45=Re*pi/180*(longdeg_vys4-longdeg_vys5)/2*mean([cos(latdeg_vys4*pi/180) cos(latdeg_vys5*pi/180)]);
  d45=2*sqrt(x45^2+y45^2);
end

vstup=load([cestadata file3MHz],'r');
time=vstup(:,1);

% Doppler shift
s1=vstup(:,2); 
 s1=s1-mean(s1);
s2=vstup(:,3);
 s2=s2-mean(s2);
s3=vstup(:,4);
 s3=s3-mean(s3);
 
if auto 
 % power
 pw1=vstup(:,5);
 pw2=vstup(:,6);
 pw3=vstup(:,7);
 % Quality of spectral peak
 q1=vstup(:,8);
 q2=vstup(:,9);
 q3=vstup(:,10);
end
 
if poctras3MHz>3 
  s4=vstup(:,5);
   s4=s4-mean(s4);
end  
if poctras3MHz>4
   s5=vstup(:,6);
   s5=s5-mean(s5); 
end 
 
 dt=mean(diff(time));
  TIDanal=1;
  
if auto 
 % use last 45 min to detected TIDs or spread
 last45=find(time>45*60); % last 45 minutes
 % detect TIDs in last 45 min
 dobreDet1=find((pw1(last45)>prahpw)&(q1(last45)>=prahqu));  % good fit
 dobreDet2=find((pw2(last45)>prahpw)&(q2(last45)>=prahqu));
 dobreDet3=find((pw3(last45)>prahpw)&(q3(last45)>=prahqu));
 TIDdetected=0;
 Sdetected='NO'; 
 if (length(dobreDet1)+length(dobreDet2)+length(dobreDet3))>3*30;
    RMS=(std(s1(dobreDet1),1).^2+std(s2(dobreDet2),1).^2+std(s3(dobreDet3),1).^2)/3; 
    if RMS>prahTID
        TIDdetected=1;
        Sdetected='TID'
    else
        TIDdetected=-1;
    end
 end
 % detect spread in last 45 min
 spreadDet1=find((pw1(last45)>prahpw)&(q1(last45)<prahqu));  % probably spread
 spreadDet2=find((pw2(last45)>prahpw)&(q2(last45)<prahqu));
 spreadDet3=find((pw3(last45)>prahpw)&(q3(last45)<prahqu));
 spreaddetected=0;
 if (length(spreadDet1)+length(spreadDet2)+length(spreadDet3))>3*30;
    spreaddetected=1;
    Sdetected='SPREAD'
 end
 
 % decide if TIDs can be analyzed in last 90 min
 dobre1=find((pw1>prahpw)&(q1>=prahqu));  % good fit
 dobre2=find((pw2>prahpw)&(q2>=prahqu));  % good fit
 dobre3=find((pw3>prahpw)&(q3>=prahqu));  % good fit
 TIDanal=0;
 if (length(dobre1)+length(dobre2)+length(dobre3))>3*70;
     TIDanal=1
     Sdetected='TIDanal'
 end 
end

 fidtext=fopen([cestaprint outtext],'a');
 if fidtext ~= -1
     % fprintf(fidtext,[sdate stime '   ' Sdetected skon]);
 end
 statustext=fclose(fidtext); 
 
 if TIDanal
 
 % calculate spectrum and dominant frequency
 Ns=length(s1);
 NFFT=2^nextpow2(Ns);
 sp1=fft(s1,NFFT);
 pwsp1=sp1.*conj(sp1);
 sp2=fft(s2,NFFT);
 pwsp2=sp2.*conj(sp2);
 sp3=fft(s3,NFFT);
 pwsp3=sp3.*conj(sp3);
 Tsp=dt*NFFT;
 %hledod
 freq=1/Tsp*(1:floor(NFFT/2)-1);
 % create mean spectrum
 powerspectr=1/3*(pwsp1+pwsp2+pwsp3);
 
%  figure(11)
%  plot(freq,powerspectr(2:floor(NFFT/2))*2/NFFT^2*NFFT/Ns,'-b.')
%  hold on
%  grid on
%  xlabel('frequency (Hz)')
%  ylabel('power spectrum (Hz^2/Hz)')
 % find spectral peak and its uncertainty
[fmax fmaxi]=max(powerspectr(2:floor(NFFT/2))*2/NFFT^2*NFFT/Ns)
 fmaxr=freq(fmaxi) % frequency of maximum
 % fine maximum
 pom=(powerspectr(fmaxi+2)-powerspectr(fmaxi))/(2*powerspectr(fmaxi+1)-(powerspectr(fmaxi+2)-powerspectr(fmaxi)))/2/Tsp; % quadratic interpolation for maximum
 fmaxr=fmaxr+pom;
 
%  plot([0 freq(end)],[fmax/2 fmax/2],'r')
 
 %[pom fmmi]=min(abs(fmax/2-powerspectr(2:fmaxi)*2/NFFT^2*NFFT/N));
 pom=find(powerspectr(2:fmaxi)*2/NFFT^2*NFFT/Ns<(fmax/2));
 if isempty(pom)
    fmmi=1;
 else
    fmmi=pom(end);
 end
 fmaxr1=freq(fmmi) % lower frequency for one half of maximum
 %[pom fmpi]=min(abs(fmax/2-powerspectr(fmaxi:floor(NFFT/2))*2/NFFT^2*NFFT/N));
 pom=find(powerspectr(fmaxi:floor(NFFT/2))*2/NFFT^2*NFFT/Ns<(fmax/2));
 fmpi=pom(1);
 fmaxr2=freq(fmaxi+fmpi) % upper frequency for one half of maximum
 dfmaxr=0.5*(fmaxr2-fmaxr1)
 omegar=2*pi*fmaxr
 domegar=2*pi*dfmaxr;
 Tpm=1/fmaxr/60;
 dTpm=0.5*(1/fmaxr1-1/fmaxr2)/60;
 
 sTpm=num2str(Tpm,'%3.1f');
 sdTpm=num2str(dTpm,'%2.2f');
 
 if (filter>=1) % analyze velocities from signal
     [b a]=butter(4,[1/HPF 1/LPF]*dt*2,'bandpass'); 
      y=filtfilt(b,a,s1);
      s1=y';
      y=filtfilt(b,a,s2);
      s2=y';
      y=filtfilt(b,a,s3);
      s3=y';
     if (poctras3MHz>3)
      y=filtfilt(b,a,s4);
      s4=y';
     end
     if (poctras3MHz>4)
      y=filtfilt(b,a,s5);
      s5=y';
     end
      
 end
 
Mp=length(time); % length of time series in sample
s1p=s1; s2p=s2; s3p=s3;
  % simulate identical shifted signals
  % s2p(1:Mp)=s1p(1:Mp); s3p(1:Mp-6)=s1p(7:Mp);   
   
% evaluate Energies for different slownesses
krokslow=5*1e-4;
slowxi=-12*1e-3:krokslow:12*1e-3;
slowyi=slowxi;
%slowzi=slowxi;
NS=length(slowxi);
if poctras3MHz==3
    si=round( (max(abs([dx1 dx2 dx3]*slowxi(1))) + max(abs([dy1 dy2 dy3]*slowyi(1))) )/dt ); % estimate security interval in indexed term for shifting 
    errprah2=(30/sqrt(3-2))^2*(1/mean(abs([dx1 dx2 dx3]))^2+1/mean(abs([dy1 dy2 dy3]))^2);
end
if poctras3MHz==4
    si=round( (max(abs([dx1 dx2 dx3 dx4]*slowxi(1))) + max(abs([dy1 dy2 dy3 dy4]*slowyi(1))) )/dt ); % estimate security interval in indexed term for shifting 
    errprah2=(30/sqrt(4-2))^2*(1/mean(abs([dx1 dx2 dx3 dx4]))^2+1/mean(abs([dy1 dy2 dy3 dy4]))^2);
end
if poctras3MHz==5
    si=round( (max(abs([dx1 dx2 dx3 dx4 dx5]*slowxi(1))) + max(abs([dy1 dy2 dy3 dy4 dy5]*slowyi(1))) )/dt ); % estimate security interval in indexed term for shifting 
    errprah2=(30/sqrt(5-2))^2*(1/mean(abs([dx1 dx2 dx3 dx4 dx5]))^2+1/mean(abs([dy1 dy2 dy3 dy4 dy5]))^2);
end
errprah=sqrt(errprah2)

if slowcor==1
 % compute time delays from the 1D crosscorrelation functions
 cr12=xcorr(s1p,s2p,2*si,'coeff');
 cr13=xcorr(s1p,s3p,2*si,'coeff');
 cr23=xcorr(s2p,s3p,2*si,'coeff');
 % maxima of cross-correlations and their positions
 [r12 t12i]=max(cr12);
 [r13 t13i]=max(cr13);
 [r23 t23i]=max(cr23);
 maxCn=(r12+r13+r23)/3;
 % times of maxima
 t12=(t12i-2*si-1)*dt;
 t13=(t13i-2*si-1)*dt;
 t23=(t23i-2*si-1)*dt; 
 % solve the set of equations for slowness components
%  tvect=[t12 t13 t23]';
%  MM(1,1)=x12; MM(1,2)=y12;
%  MM(2,1)=x13; MM(2,2)=y13;
%  MM(3,1)=x23; MM(3,2)=y23;
%  scor=(MM'*MM)^-1*MM'*tvect;
 % directly by LS
 AM(1,1)=x12^2+x13^2+x23^2;
 AM(1,2)=x12*y12+x13*y13+x23*y23;
 AM(2,1)=AM(1,2);
 AM(2,2)=y12^2+y13^2+y23^2;
 YM(1)=t12*x12+t13*x13+t23*x23;
 YM(2)=t12*y12+t13*y13+t23*y23;
 scorLS=AM^-1*YM';
 
 sabsLS=sqrt(scorLS(1)^ 2+scorLS(2)^2);
 vLS=1/sabsLS;
 AZcor0=atan2(scorLS(2),scorLS(1));
 AZLS=90-AZcor0*180/pi;  % azimuth
 if AZLS<0 AZLS=AZLS+360; end 
 
 % by weighted LS
 AM(1,1)=x12^2/r12^2+x13^2/r13^2+x23^2/r23^2;
 AM(1,2)=x12*y12/r12^2+x13*y13/r13^2+x23*y23/r23^2;
 AM(2,1)=AM(1,2);
 AM(2,2)=y12^2/r12^2+y13^2/r13^2+y23^2/r23^2;
 YM(1)=t12*x12/r12^2+t13*x13/r13^2+t23*x23/r23^2;
 YM(2)=t12*y12/r12^2+t13*y13/r13^2+t23*y23/r23^2;
 scorLSw=AM^-1*YM';
 
 sabsLSw=sqrt(scorLSw(1)^2+scorLSw(2)^2);
 vLSw=1/sabsLSw;
 AZcor0=atan2(scorLSw(2),scorLSw(1));
 AZLSw=90-AZcor0*180/pi;  % azimuth
 if AZLSw<0 AZLSw=AZLSw+360; end 
 
 %residua=sqrt(sum((tvect-MM*scor).^2));

 
 
end

rEmax=0;
for erest=1:length(pocv)
 poc=pocv(erest); kon=konv(erest);   
    
% select the subinterval 
poci=round(poc*(60/dt)-1);
if poci<1 poci=1; end
koni=round(kon*(60/dt)-1);
if koni>Mp koni=Mp; end
s1=s1p(poci:koni); s2=s2p(poci:koni); s3=s3p(poci:koni);
M=length(s1); % actual length of subinterval 
 
divN=0;
Eunc=0; % variable for uncorrelated noise energy
Ep=[];
Ep(NS,NS)=0; % Energy matrix
% now cycles


maxE=0; 
for i=1:NS
  slowx=slowxi(i)  
  for j=1:NS
    slowy=slowyi(j);
%     for k=1:NS
%       slowz=slowzi(k);  
      for tt=si+2:M-si-1
           tt1=tt+(dx1*slowx+dy1*slowy)/dt; % indexed time to interpolate y1
           yt1=s1(floor(tt1)) + (s1(floor(tt1)+1)-s1(floor(tt1)))*(tt1-floor(tt1)); % interpolated y1
           tt2=tt+(dx2*slowx+dy2*slowy)/dt; % indexed time to interpolate y2
           yt2=s2(floor(tt2)) + (s2(floor(tt2)+1)-s2(floor(tt2)))*(tt2-floor(tt2)); % interpolated y2
           tt3=tt+(dx3*slowx+dy3*slowy)/dt; % indexed time to interpolate y3
           yt3=s3(floor(tt3)) + (s3(floor(tt3)+1)-s3(floor(tt3)))*(tt3-floor(tt3)); % interpolated y3
           
           if poctras3MHz==3
             ys=(yt1+yt2+yt3)/3; % average signal after interference
             Ep(i,j)=Ep(i,j)+ys^2;
           end
           if poctras3MHz==4
              tt4=tt+(dx4*slowx+dy4*slowy)/dt; % indexed time to interpolate y4
              yt4=s4(floor(tt4)) + (s4(floor(tt4)+1)-s4(floor(tt4)))*(tt4-floor(tt4)); % interpolated y4
              ys=(yt1+yt2+yt3+yt4)/4; % average signal after interference
              Ep(i,j)=Ep(i,j)+ys^2;     
           end
           if poctras3MHz==5
              tt4=tt+(dx4*slowx+dy4*slowy)/dt; % indexed time to interpolate y4
              yt4=s4(floor(tt4)) + (s4(floor(tt4)+1)-s4(floor(tt4)))*(tt4-floor(tt4)); % interpolated y4
              tt5=tt+(dx5*slowx+dy5*slowy)/dt; % indexed time to interpolate y5
              yt5=s5(floor(tt5)) + (s5(floor(tt5)+1)-s5(floor(tt5)))*(tt5-floor(tt5)); % interpolated y5 
              ys=(yt1+yt2+yt3+yt4+yt5)/5; % average signal after interference
              Ep(i,j)=Ep(i,j)+ys^2;  
           end
      end
       if  maxE<Ep(i,j)
          maxE=Ep(i,j);
          maxie(erest)=i; maxje(erest)=j;
       end
       
%    end
  end  
end

 figure(1)
 plot(time,s1p,'-r.')
 hold on
 plot(time,s2p,'-g.')
 plot(time,s3p,'-b.')
 if (Herm==0)&(poctras3MHz>3)
   plot(time,s4,'-c.')
   plot(time,s5,'-m.')
 end
 plot([poci*dt poci*dt],[-1 1],'m');
 plot([koni*dt koni*dt],[-1 1],'m');
 plot([(poci+si+1)*dt (poci+si+1)*dt],[-1 1],'--m');
 plot([(koni-si)*dt (koni-si)*dt],[-1 1],'--m');
 
 xlabel('time (s)')
 ylabel('\Deltaf')
 grid on
 hold off
 
 Epn=Ep/M; % normalize by the interval length
 maxEn(erest)=maxE/M;
 Pav(erest)=mean([std(s1,1)^2 std(s2,1)^2 std(s3,1)^2 std(s1p,1)^2 std(s2p,1)^2 std(s3p,1)^2]); % average power uncorelated
 rEm(erest)=maxEn(erest)/Pav(erest);
 if rEm(erest)>rEmax
   rEmax=rEm(erest);
   Epnm=Epn/Pav(erest);
   Pavm=Pav(erest);
 end
 
end % for erest 



'maxEn  Pav  rEm' 
[maxEn' Pav' rEm']
ven=find(rEm<prah);
rEm(ven)=0;  % put low weights to zero 

%if ((erest-length(ven))>=2)&(slowcor==0)
%   maxi=round(sum(rEm.*maxie)/sum(rEm))
%   maxj=round(sum(rEm.*maxje)/sum(rEm))
maxi=maxie;
maxj=maxje;


  sabs=sqrt(slowxi(maxi)^2+slowyi(maxj)^2) % absolute values of slowness
  phi0r=atan2(slowyi(maxj),slowxi(maxi));
  phic=90-phi0r*180/pi;  % azimuth
  if phic<0 phic=phic+360; end 
  AZm=phic;
  erri2=sum(rEm.*(maxie-maxi).^2)/sum(rEm);
  errj2=sum(rEm.*(maxje-maxj).^2)/sum(rEm);
  errs0=0.5*krokslow
  errx=sqrt(errs0^2+erri2*krokslow^2)
  erry=sqrt(errs0^2+errj2*krokslow^2)
  errs=sqrt(errx^2+erry^2)
  sabsmax=sabs+errx*abs(cos(phi0r))+erry*abs(sin(phi0r)); % max value of slowness in radial direction to basic value 
  sabsmin=sabs-errx*abs(cos(phi0r))-erry*abs(sin(phi0r)); 
  dslowphi=errx*abs(sin(phi0r))+erry*abs(cos(phi0r))  % error of slowness in azimuthal direction
  dAZm=atan(dslowphi/sabs)*180/pi
  vabs=0.5*(1/sabsmin+1/sabsmax)
  vabsm=vabs;
  dvabs=0.5*(1/sabsmin-1/sabsmax)
  if (vabs<=0)|(errs>errprah)
    vabs=9999; dvabs=9999; phic=999; dAZm=999;  
  end
%else
%    vabs=9999; dvabs=9999; phic=999; dAZm=999;
%end

if slowcor>=1
    %if (rEmax>=prah)&(maxCn>=prah)&(residua<3*30)
        
       %calculate parameters and their uncertainties from 3 different methods 
       sabs=sqrt(slowxi(maxie)^2+slowyi(maxje)^2); % absolute values of slowness
       vabsm=mean([1/sabs vLS vLSw]);
       dvabs=std([1/sabs vLS vLSw]);
       sabsm=mean([sabs sabsLS sabsLSw]);
       dsabs=std([sabs sabsLS sabsLSw]);
       sxm=mean([slowxi(maxie) scorLS(1) scorLSw(1)]);
       dsx=std([slowxi(maxie) scorLS(1) scorLSw(1)]);
       sym=mean([slowyi(maxje) scorLS(2) scorLSw(2)]);
       dsy=std([slowyi(maxje) scorLS(2) scorLSw(2)]);
       pom=atan2(sym,sxm);
       AZm=90-pom*180/pi;
       if AZm<0 AZm=360+AZm; end
       dAZm=atan((dsx*abs(sin(pom))+dsy*abs(cos(pom)))/sabsm)*180/pi;
       
%        slowxf=0.5*(scor(1)+slowxi(maxie));
%        slowyf=0.5*(scor(2)+slowyi(maxje));
%      
%        sabs=sqrt(slowxf^2+slowyf^2) % absolute values of slowness
%        phi0r=atan2(slowyf,slowxf);
%        phic=90-phi0r*180/pi;  % azimuth
%        if phic<0 phic=phic+360; end
%        
%        errs=sqrt( 2*(slowxf-scor(1))^2 + 2*(slowyf-scor(2))^2 ) % absolute value of slowness error vector 
%        errs0=0.5*krokslow
%        errx=sqrt(errs0^2+2*(slowxf-scor(1))^2)
%        erry=sqrt(errs0^2+2*(slowyf-scor(2))^2)
%        sabsmax=sabs+errx*abs(cos(phi0r))+erry*abs(sin(phi0r)); % max value of slowness in radial direction to basic value 
%        sabsmin=sabs-errx*abs(cos(phi0r))-erry*abs(sin(phi0r)); 
%        dslowphi=errx*abs(sin(phi0r))+erry*abs(cos(phi0r))  % error of slowness in azimuthal direction
%        dAZ=atan(dslowphi/sabs)*180/pi
%        vabs=0.5*(1/sabsmin+1/sabsmax)
%        dvabs=0.5*(1/sabsmin-1/sabsmax)
       if (vabsm<=0)|(dvabs/vabs>1);
         vabsm=9999; dvabs=9999; AZm=999; dAZm=999;  
       end
%     else
%         vabs=9999; dvabs=9999; phic=999; dAZ=999;
%     end
end

svabs=num2str(vabsm,'%06.1f'); sdvabs=num2str(dvabs,'%07.2f');
sAZ=num2str(AZm,'%05.1f'); sdAZ=num2str(dAZm,'%06.2f');
srEm=num2str(rEmax,'%01.3f'); sdfRMS=num2str(sqrt(Pavm),'%01.3f');


%if slowcor==0
   figure(2)
 
   colormap(jet)
   pcolor((slowxi-krokslow/2)*1000,(slowyi-krokslow/2)*1000,Epnm')
   shading flat
   hold on
   xlabel('s_x (s/km)')
   ylabel('s_y (s/km)')
   %elev=atan(slowzi(maxk)/sqrt(slowxi(maxi)^2+slowyi(maxj)^2))*180/pi;
   
   title(['AZ=' num2str(phic,5) '^o;    v_h=' num2str(vabs,4) 'm/s'])
   %title([sletter '\rm: ' sod ' ;  \Deltat=' int2str(delka) ' s'])
   colorbar 
   grid on
   set(gca,'YTick',[-12:1:12])
   set(gca,'XTick',[-12:1:12])
   %xlim([-2.5 2.5])
   %ylim([-2.5 2.5])
   caxis([0 1])
   
    %draw azimuth in 30 deg step
   phii=0:30:345;
   for iphi=1:length(phii)
       phi=phii(iphi);
       sx=12*cos(phi*pi/180);
       sy=12*sin(phi*pi/180);
       plot([0 sx],[0 sy],'k--');
   end
   text(0.2,11.0,'0^o');
   text(10.6,0.6,'90^o');
   text(0.2,-11.5,'180^o');
   text(-12.0,0.6,'270^o');
   %draw velocities in 50 m/steps
   vhsti=[100 120 150 200 300]
   for vv=1:length(vhsti)
     vhst=vhsti(vv);  
     for phi=0:360  
       sx(phi+1)=1000/vhst*cos(phi*pi/180);
       sy(phi+1)=1000/vhst*sin(phi*pi/180);
     end
     plot(sx,sy,'k--')
     text(cos(60*pi/180)*1000/vhst+0.3,sin(60*pi/180)*1000/vhst+0.3,[int2str(vhst) ' m/s'],'Rotation',-32-vv)
   end
%end  
   
   %[sdate stime '   ' svabs '  ' sdvabs '   ' sAZ '  ' sdAZ '   ' srEm '  ' sdfRMS '  ' speriod skon]
   if tiskni
     if tiskni==2  
         print('-djpeg', '-r300', [cestaprint file3MHz(1:14) int2str(round((time(end)+30)/60)) '_' num2str(round(LPF/60)) '_' num2str(round(HPF/60)) '_slowxy']);
     end
     fidtext=fopen([cestaprint outtext],'a');
     if fidtext ~= -1
         fprintf(fidtext,[sUTC '    ' svabs '  ' sdvabs '   ' sAZ '  ' sdAZ '   ' srEm  '   ' sdfRMS '  ' sTpm '   ' sdTpm '   ' sfreq skon]);
     end
     statustext=fclose(fidtext); 
   end
  
   
  end % TIDanal 
   
  end  % analyze file
    end % ~feof(fidlist)   
   status=fclose(fidlist);
else % fidlist==-1
    'file not opened'
end
   
   
